Subject: [quicwg/base-drafts] Negative base values are invalid (#4940)

From: Martin Thomson <[email-masked]>
Date: Mon, 04 Oct 2021 17:05:47 -0700

Happy to use MAY here, which would be fine in terms of achieving our goals.

Signed math is entirely valid here, but it introduces other problems; as there is no need to go negative (it&#39;s less efficient), this seems safest.

This is what people have implemented - at least in some cases - but we should confirm.  

Closes #4938.
You can view, comment on, or merge this pull request online at:

  https://github.com/quicwg/base-drafts/pull/4940

-- Commit Summary --

  * <a href="https://github.com/quicwg/base-drafts/pull/4940/commits/0e22ccf23a80b74848b0431a8f4ec99b2b8b5c44">Negative base values are invalid</a>

-- File Changes --

    M draft-ietf-quic-qpack.md (6)

-- Patch Links --

https://github.com/quicwg/base-drafts/pull/4940.patch
https://github.com/quicwg/base-drafts/pull/4940.diff

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940

---

From: Mike Bishop <[email-masked]>
Date: Mon, 04 Oct 2021 19:17:33 -0700

@MikeBishop approved this pull request.

I'm also ambivalent between MUST and MAY.  Our principle is that easily detected errors are mandatory and difficult to detect are optional, though, so MUST is appropriate by that rule.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940#pullrequestreview-770918947

---

From: Lucas Pardue <[email-masked]>
Date: Fri, 29 Oct 2021 12:31:34 -0700

@kazuho does this address the issue you raised on #4938?

@afrind any thoughts as the document editor?

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940#issuecomment-954998770

---

From: afrind <[email-masked]>
Date: Fri, 29 Oct 2021 12:55:36 -0700

@afrind approved this pull request.

I like the MUST there.  

Do we need to say anything about the S=0 case overflowing (eg: a prefix with a very large DeltaBase that would wrap)?  I'm sort of inclined to leave it.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940#pullrequestreview-793405995

---

From: Martin Thomson <[email-masked]>
Date: Fri, 29 Oct 2021 14:51:44 -0700

Is that X>MaxEntries? Or X>2^64 ( or whatever maximum your implementation might want given that your tables can be sized to allow smaller representations)…?

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940#issuecomment-955068163

---

From: Kazuho Oku <[email-masked]>
Date: Sat, 30 Oct 2021 01:18:55 -0700

@kazuho approved this pull request.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940#pullrequestreview-793549354

---

From: Kazuho Oku <[email-masked]>
Date: Sat, 30 Oct 2021 01:37:35 -0700

@LPardue
> does this address the issue you raised on #4938?

Thank you. It does.

Re overflow (of integers), +1 to _not_ saying anything.

Delta Base uses HPACK integer representation. [RFC 7541 section 7.1](https://datatracker.ietf.org/doc/html/rfc7541#section-7.4) already has cautionary text regarding large values.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/4940#issuecomment-955173767